#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "widgets_int.h"

GtkWidget*
create_top (void)
{
  GtkWidget *top;
  GtkWidget *vbox1;
  GtkWidget *handlebox2;
  GtkWidget *hbox2;
  GtkWidget *toolbar1;
  GtkWidget *pixmap3;
  GtkWidget *handlebox3;
  GtkWidget *hbox4;
  GtkWidget *hbox5;
  GtkWidget *label13;
  GtkWidget *hbox6;
  GtkWidget *label14;
  GtkWidget *handlebox4;
  GtkWidget *hbox7;
  GtkWidget *label16;
  GtkWidget *scrolledwindow5;
  GtkWidget *toolbar3;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *label9;
  GtkWidget *scrolledwindow4;
  GtkWidget *label10;
  GtkWidget *vbox2;
  GtkWidget *pixmap2;
  GtkWidget *hbox9;
  GtkWidget *label15;
  GtkWidget *label24;
  GtkWidget *frame2;
  GtkWidget *hbox10;
  GtkWidget *scrolledwindow6;
  GtkWidget *hbox11;
  GtkWidget *label11;
  GtkWidget *hbox8;
  GtkWidget *tmpW;
  GList *glistBrowse = NULL, *glistPattern = NULL;
  gchar *cwd;

  top = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (top), "top", top);
  gtk_window_set_title (GTK_WINDOW (top), _("[  0.1  t u r m a  ]"));
/* It's a good idea to do this for all windows. */
    gtk_signal_connect (GTK_OBJECT (top), "destroy",
                        GTK_SIGNAL_FUNC (cb_Exit), NULL);

    gtk_signal_connect (GTK_OBJECT (top), "delete_event",
                        GTK_SIGNAL_FUNC (cb_Exit), NULL);

 
  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (top), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (top), vbox1);

  handlebox2 = gtk_handle_box_new ();
  gtk_widget_ref (handlebox2);
  gtk_object_set_data_full (GTK_OBJECT (top), "handlebox2", handlebox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox2);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox2, FALSE, FALSE, 0);
  gtk_handle_box_set_snap_edge (GTK_HANDLE_BOX (handlebox2), GTK_POS_LEFT);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (handlebox2), hbox2);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (top), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (hbox2), toolbar1, TRUE, TRUE, 0);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar1), GTK_RELIEF_NONE);
  gtk_container_set_border_width (GTK_CONTAINER (toolbar1), 2);

  tmp_toolbar_icon = create_pixmap (top, "open.xpm");
  bOpen = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("  Open  "),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (bOpen);
  gtk_object_set_data_full (GTK_OBJECT (top), "bOpen", bOpen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect(GTK_OBJECT(bOpen), "clicked", GTK_SIGNAL_FUNC (cb_Open), NULL);
  gtk_widget_show (bOpen);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar1));

  tmp_toolbar_icon = create_pixmap (top, "exit.xpm");
  bExit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("  Exit  "),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (bExit);
  gtk_object_set_data_full (GTK_OBJECT (top), "bExit", bExit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect(GTK_OBJECT(bExit), "clicked", GTK_SIGNAL_FUNC (cb_Exit), NULL);
  gtk_widget_show (bExit);

  pixmap3 = create_pixmap (top, "vbd.xpm");
  gtk_widget_ref (pixmap3);
  gtk_object_set_data_full (GTK_OBJECT (top), "pixmap3", pixmap3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap3);
  gtk_box_pack_start (GTK_BOX (hbox2), pixmap3, FALSE, FALSE, 0);

  handlebox3 = gtk_handle_box_new ();
  gtk_widget_ref (handlebox3);
  gtk_object_set_data_full (GTK_OBJECT (top), "handlebox3", handlebox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox3);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox3, FALSE, FALSE, 0);
  gtk_handle_box_set_snap_edge (GTK_HANDLE_BOX (handlebox3), GTK_POS_LEFT);

  hbox4 = gtk_hbox_new (FALSE, 10);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), 2);
  gtk_container_add (GTK_CONTAINER (handlebox3), hbox4);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (hbox4), hbox5, TRUE, TRUE, 0);

  label13 = gtk_label_new (_("Location:"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (top), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (hbox5), label13, FALSE, FALSE, 3);
  gtk_label_set_justify (GTK_LABEL (label13), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_padding (GTK_MISC (label13), 2, 0);

  comboBrowse = gtk_combo_new ();
  gtk_widget_ref (comboBrowse);
  gtk_object_set_data_full (GTK_OBJECT (top), "comboBrowse", comboBrowse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (comboBrowse);
  gtk_box_pack_start (GTK_BOX (hbox5), comboBrowse, TRUE, TRUE, 0);

  comboBrowse_entry = GTK_COMBO (comboBrowse)->entry;
  gtk_entry_set_editable ( GTK_ENTRY (comboBrowse_entry), FALSE );
  gtk_widget_ref (comboBrowse_entry);
  gtk_object_set_data_full (GTK_OBJECT (top), "comboBrowse_entry", comboBrowse_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (comboBrowse_entry);
  
  cwd = g_get_current_dir ();
  cwd = g_realloc ( cwd, strlen (cwd) + 2 );
  /* let's see how funny could it be... */
  sprintf ( cwd, "%s/", cwd );
  tmpW = gtk_list_item_new_with_label ( cwd );
  gtk_widget_show ( tmpW );
  glistBrowse = g_list_append ( glistBrowse, tmpW );
  gtk_list_append_items ( GTK_LIST ( GTK_COMBO (comboBrowse) -> list ),
		  glistBrowse);
  gtk_list_select_item ( GTK_LIST ( GTK_COMBO (comboBrowse) -> list ), 0);
  g_free (cwd);

  gtk_signal_connect ( GTK_OBJECT ( comboBrowse_entry ), "changed",
		  GTK_SIGNAL_FUNC (cb_scrollEntry), NULL );

  bBrowse = gtk_button_new_with_label (_("Browse..."));
  gtk_widget_ref (bBrowse);
  gtk_object_set_data_full (GTK_OBJECT (top), "bBrowse", bBrowse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_button_set_relief( GTK_BUTTON(bBrowse), GTK_RELIEF_HALF);
  gtk_signal_connect(GTK_OBJECT(bBrowse), "clicked", GTK_SIGNAL_FUNC(cb_Browse), NULL);
  gtk_widget_show (bBrowse);
  gtk_box_pack_start (GTK_BOX (hbox5), bBrowse, FALSE, FALSE, 0);

  hbox6 = gtk_hbox_new (FALSE, 3);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (hbox4), hbox6, FALSE, FALSE, 0);

  label14 = gtk_label_new (_("Pattern:"));
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (top), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_box_pack_start (GTK_BOX (hbox6), label14, FALSE, FALSE, 2);
  gtk_label_set_justify (GTK_LABEL (label14), GTK_JUSTIFY_RIGHT);

  comboPattern = gtk_combo_new ();
  gtk_widget_ref (comboPattern);
  gtk_object_set_data_full (GTK_OBJECT (top), "comboPattern", comboPattern,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (comboPattern);
  gtk_box_pack_start (GTK_BOX (hbox6), comboPattern, FALSE, FALSE, 0);

  comboPattern_entry = GTK_COMBO (comboPattern)->entry;
  gtk_widget_ref (comboPattern_entry);
  gtk_object_set_data_full (GTK_OBJECT (top), "comboPattern_entry", comboPattern_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (comboPattern_entry);
  tmpW = gtk_list_item_new_with_label ( "*" );
  gtk_widget_show ( tmpW );
  glistPattern = g_list_append ( glistPattern, tmpW );
  gtk_list_append_items ( GTK_LIST ( GTK_COMBO (comboPattern) -> list ),
		  glistPattern);
  gtk_list_select_item ( GTK_LIST ( GTK_COMBO (comboPattern) -> list ), 0);

  cRecursive = gtk_check_button_new_with_label (_("Recursive"));
  gtk_widget_ref (cRecursive);
  gtk_object_set_data_full (GTK_OBJECT (top), "cRecursive", cRecursive,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cRecursive);
  gtk_signal_connect ( GTK_OBJECT(cRecursive), "toggled",
		  GTK_SIGNAL_FUNC(cb_Recursive), cRecursive);
  gtk_box_pack_start (GTK_BOX (hbox4), cRecursive, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cRecursive), TRUE);

  handlebox4 = gtk_handle_box_new ();
  gtk_widget_ref (handlebox4);
  gtk_object_set_data_full (GTK_OBJECT (top), "handlebox4", handlebox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox4);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox4, TRUE, TRUE, 0);
  gtk_handle_box_set_snap_edge (GTK_HANDLE_BOX (handlebox4), GTK_POS_LEFT);

  gtk_container_set_border_width (GTK_CONTAINER (handlebox4), 2);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (top), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_signal_connect_after ( GTK_OBJECT (notebook1), "switch_page",
		  GTK_SIGNAL_FUNC (cb_switchpage), NULL);
  gtk_container_add (GTK_CONTAINER (handlebox4), notebook1);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook1), TRUE);
  gtk_notebook_set_show_border(GTK_NOTEBOOK (notebook1), FALSE);
  gtk_notebook_popup_enable (GTK_NOTEBOOK (notebook1));

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (notebook1), hbox7);

  packer2 = gtk_packer_new ();
  gtk_packer_set_default_pad (GTK_PACKER (packer2), 10, 0);
  gtk_widget_ref (packer2);
  gtk_object_set_data_full (GTK_OBJECT (top), "packer2", packer2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (packer2);
  gtk_box_pack_start (GTK_BOX (hbox7), packer2, TRUE, TRUE, 0);

  label16 = gtk_label_new (_("Search for"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (top), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_packer_add_defaults (GTK_PACKER (packer2), label16, GTK_SIDE_TOP,
                           GTK_ANCHOR_NORTH_WEST, (GtkPackerOptions) (0));

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (top), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_packer_add_defaults (GTK_PACKER (packer2), scrolledwindow2, GTK_SIDE_TOP,
                           GTK_ANCHOR_NORTH_WEST, (GtkPackerOptions) (GTK_EXPAND | GTK_FILL_X | GTK_FILL_Y));
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  tSearch = gtk_text_new (NULL, NULL);
  gtk_widget_ref (tSearch);
  gtk_object_set_data_full (GTK_OBJECT (top), "tSearch", tSearch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tSearch);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), tSearch);
  gtk_text_set_editable (GTK_TEXT (tSearch), TRUE);

  cReplace = gtk_check_button_new_with_label (_("Replace with"));
  gtk_widget_ref (cReplace);
  gtk_object_set_data_full (GTK_OBJECT (top), "cReplace", cReplace,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cReplace);
  gtk_signal_connect ( GTK_OBJECT(cReplace), "toggled",
		GTK_SIGNAL_FUNC(cb_Replace), cReplace);
  gtk_packer_add_defaults (GTK_PACKER (packer2), cReplace, GTK_SIDE_TOP,
                           GTK_ANCHOR_NORTH_WEST, (GtkPackerOptions) (GTK_FILL_X));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cReplace), FALSE);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (top), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_packer_add_defaults (GTK_PACKER (packer2), scrolledwindow3, GTK_SIDE_TOP,
                           GTK_ANCHOR_NORTH_WEST, (GtkPackerOptions) (GTK_EXPAND | GTK_FILL_X | GTK_FILL_Y));
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  tReplace = gtk_text_new (NULL, NULL);
  gtk_widget_ref (tReplace);
  gtk_object_set_data_full (GTK_OBJECT (top), "tReplace", tReplace,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tReplace);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), tReplace);
  gtk_text_set_editable (GTK_TEXT (tReplace), TRUE);
  gtk_widget_set_sensitive ( tReplace, FALSE );

  evBox1 = gtk_event_box_new ();
  gtk_widget_ref (evBox1);
  gtk_object_set_data_full (GTK_OBJECT (top), "evBox1", evBox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (evBox1);
  gtk_packer_add_defaults (GTK_PACKER (packer2), evBox1, GTK_SIDE_TOP,
                           GTK_ANCHOR_NORTH_EAST, (GtkPackerOptions) (GTK_FILL_Y));
  gtk_widget_set_events (evBox1, GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect (GTK_OBJECT(evBox1), "button_press_event",      
                        GTK_SIGNAL_FUNC (cb_Arrow), arrow1);

  arrow1 = gtk_arrow_new (GTK_ARROW_DOWN, GTK_SHADOW_OUT);
  gtk_widget_ref (arrow1);
  gtk_object_set_data_full (GTK_OBJECT (top), "arrow1", arrow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow1);
  gtk_container_add (GTK_CONTAINER (evBox1), arrow1);

  frame1 = gtk_frame_new (_("Results"));
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (top), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
/*  gtk_packer_add_defaults (GTK_PACKER (packer2), frame1, GTK_SIDE_TOP,
                           GTK_ANCHOR_NORTH_WEST, (GtkPackerOptions) (GTK_PACK_EXPAND | GTK_FILL_X | GTK_FILL_Y));
*/
  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (top), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_container_add (GTK_CONTAINER (frame1), scrolledwindow5);
  gtk_container_set_border_width ( GTK_CONTAINER (scrolledwindow5), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist = gtk_clist_new (5);
  gtk_widget_ref (clist);
  gtk_object_set_data_full (GTK_OBJECT (top), "clist", clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), clist);

  gtk_clist_set_column_title (GTK_CLIST (clist), 0, "#");
  gtk_clist_set_column_title (GTK_CLIST (clist), 1, _("File") );
  gtk_clist_set_column_title (GTK_CLIST (clist), 2, _("Location") );
  gtk_clist_set_column_title (GTK_CLIST (clist), 3, _("Action") );
  gtk_clist_set_column_title (GTK_CLIST (clist), 4, _("Status") );
  
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 20);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 120);
  gtk_clist_set_column_width (GTK_CLIST (clist), 2, 210);
  gtk_clist_set_column_width (GTK_CLIST (clist), 3, 60);
  gtk_clist_set_column_width (GTK_CLIST (clist), 4, 50);
  gtk_clist_column_titles_show (GTK_CLIST (clist));

  gtk_clist_set_column_justification ( GTK_CLIST (clist), 0, GTK_JUSTIFY_RIGHT );
  gtk_clist_set_column_justification ( GTK_CLIST (clist), 1, GTK_JUSTIFY_LEFT );
  gtk_clist_set_column_justification ( GTK_CLIST (clist), 2, GTK_JUSTIFY_LEFT );
  gtk_clist_set_column_justification ( GTK_CLIST (clist), 3, GTK_JUSTIFY_CENTER );
  gtk_clist_set_column_justification ( GTK_CLIST (clist), 4, GTK_JUSTIFY_RIGHT );

/*  gtk_container_remove( GTK_CONTAINER (packer2), frame1); */

  toolbar3 = gtk_toolbar_new (GTK_ORIENTATION_VERTICAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar3);
  gtk_object_set_data_full (GTK_OBJECT (top), "toolbar3", toolbar3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar3);
  gtk_box_pack_start (GTK_BOX (hbox7), toolbar3, FALSE, FALSE, 0);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar3), 0);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar3), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar3), GTK_RELIEF_NONE);

  tmp_toolbar_icon = create_pixmap (top, "exec.xpm");
  bGo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Go\nfor it!"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (bGo);
  gtk_signal_connect ( GTK_OBJECT (bGo), "clicked",
		  GTK_SIGNAL_FUNC (cb_Go), NULL);
  gtk_object_set_data_full (GTK_OBJECT (top), "bGo", bGo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bGo);

  tmp_toolbar_icon = create_pixmap (top, "stop.xpm");
  bStop = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Stop\nthis crap!"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (bStop);
  gtk_signal_connect ( GTK_OBJECT (bStop), "clicked",
		  GTK_SIGNAL_FUNC (cb_Stop), NULL);
  gtk_object_set_data_full (GTK_OBJECT (top), "bStop", bStop,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_set_sensitive ( bStop, FALSE);
  gtk_widget_show (bStop);

  tmp_toolbar_icon = create_pixmap (top, "reload.xpm");
  bRefresh = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Refresh\nresults"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (bRefresh);
  gtk_signal_connect ( GTK_OBJECT (bRefresh), "clicked",
		  GTK_SIGNAL_FUNC (cb_Refresh), NULL);
  gtk_object_set_data_full (GTK_OBJECT (top), "bRefresh", bRefresh,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bRefresh);
  gtk_widget_set_sensitive ( bRefresh, FALSE );

  tmp_toolbar_icon = create_pixmap (top, "new.xpm");
  bNewS = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("New\nsearch"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (bNewS);
  gtk_signal_connect ( GTK_OBJECT (bNewS), "clicked",
		  GTK_SIGNAL_FUNC (cb_NewS), NULL);
  gtk_object_set_data_full (GTK_OBJECT (top), "bNewS", bNewS,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bNewS);
  /* gtk_widget_set_sensitive ( bNewS, FALSE ); */
  
  label9 = gtk_label_new (_("Search (and replace)"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (top), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label9);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (top), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clipboard = gtk_text_new (NULL, NULL);
  gtk_widget_ref (clipboard);
  gtk_object_set_data_full (GTK_OBJECT (top), "clipboard", clipboard,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clipboard);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), clipboard);

  label10 = gtk_label_new (_("Clipboard"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (top), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label10);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (top), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox2);

  pixmap2 = create_pixmap (top, "vbd2.xpm");
  gtk_widget_ref (pixmap2);
  gtk_object_set_data_full (GTK_OBJECT (top), "pixmap2", pixmap2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap2);
  gtk_box_pack_start (GTK_BOX (vbox2), pixmap2, FALSE, FALSE, 0);

  hbox9 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox9, FALSE, TRUE, 10);

  label15 = gtk_label_new (_("This is\nt u r m a, version 0.1\n(Text utils w/ recursive\nmumbo jumbos, etc...)"));
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (top), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (hbox9), label15, TRUE, TRUE, 0);
/*  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label15), TRUE); */

  label24 = gtk_label_new (_("Brought to you by\nViolence by Design,\nunder the terms of GNU GPL v2,\nin the gracefull year of 2001."));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (top), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (hbox9), label24, TRUE, TRUE, 0);

  frame2 = gtk_frame_new (_("Email your coments/feedback at vbd@go.ro"));
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (top), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, TRUE, TRUE, 0);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (frame2), hbox10);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (top), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_box_pack_start (GTK_BOX (hbox10), scrolledwindow6, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  tMail = gtk_text_new (NULL, NULL);
  gtk_widget_ref (tMail);
  gtk_object_set_data_full (GTK_OBJECT (top), "tMail", tMail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_text_set_editable ( GTK_TEXT (tMail), TRUE);
  gtk_widget_show (tMail);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), tMail);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_container_set_border_width (GTK_CONTAINER (hbox11), 2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox11, FALSE, FALSE, 0);

  bMail = gtk_button_new_with_label (_(" Send feedback "));
  gtk_widget_ref (bMail);
  gtk_object_set_data_full (GTK_OBJECT (top), "bMail", bMail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_button_set_relief(GTK_BUTTON(bMail), GTK_RELIEF_NONE);
  gtk_signal_connect ( GTK_OBJECT (bMail), "clicked",
		  GTK_SIGNAL_FUNC (cb_Mail), tMail);
  gtk_widget_show (bMail);
  gtk_box_pack_start (GTK_BOX (hbox11), bMail, TRUE, FALSE, 0);

  /* disable mail extension if don't have sendmail */
#ifndef MAILER
  gtk_text_insert ( GTK_TEXT (tMail), NULL, NULL, NULL,
		  _("sendmail not found, email disabled"), -1);
  gtk_widget_set_sensitive ( frame2, FALSE );
  gtk_widget_set_sensitive ( bMail, FALSE );
#endif

  bLink = gtk_button_new_with_label (_(" Visit the homepage at http://vbd.go.ro/software/turma/ "));
  gtk_widget_ref (bLink);
  gtk_object_set_data_full (GTK_OBJECT (top), "bLink", bLink,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_button_set_relief(GTK_BUTTON(bLink), GTK_RELIEF_NONE);
  gtk_widget_show (bLink);
  gtk_signal_connect ( GTK_OBJECT (bLink), "clicked",
		  GTK_SIGNAL_FUNC (cb_Link), NULL);
  gtk_box_pack_start (GTK_BOX (hbox11), bLink, TRUE, FALSE, 0);

  label11 = gtk_label_new (_("About"));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (top), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label11);
  gtk_misc_set_padding (GTK_MISC (label11), 17, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (top), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox8, FALSE, FALSE, 0);

  sBar = gtk_statusbar_new ();
  gtk_widget_ref (sBar);
  gtk_object_set_data_full (GTK_OBJECT (top), "sBar", sBar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sBar);
  gtk_box_pack_start (GTK_BOX (hbox8), sBar, TRUE, TRUE, 0);

  pBar = gtk_progress_bar_new ();
  gtk_widget_ref (pBar);
  gtk_object_set_data_full (GTK_OBJECT (top), "pBar", pBar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pBar);
  gtk_box_pack_start (GTK_BOX (hbox8), pBar, FALSE, FALSE, 0);

  return top;
}

