/*
 * another copy & paste file, this one from sylpheed and Gimp
 */
#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <glib.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>

#include "support.h"

#define BUFFSIZE	8192

gint execute_async(gchar *const argv[])
{
	pid_t pid;

	if ((pid = fork()) < 0) {
		perror("fork");
		return -1;
	}

	if (pid == 0) {			/* child process */
		pid_t gch_pid;

		if ((gch_pid = fork()) < 0) {
			perror("fork");
			_exit(1);
		}

		if (gch_pid == 0) {	/* grandchild process */
			execvp(argv[0], argv);

			perror("execvp");
			_exit(1);
		}

		_exit(0);
	}

	waitpid(pid, NULL, 0);

	return 0;
}

gint execute_command_line(const gchar *cmdline)
{
	gchar **argv;
	gint i;
	gint ret;

	argv = g_strsplit(cmdline, " ", strlen(cmdline));

	for (i = 0; argv[i] != NULL; i++) {
		gchar *str = argv[i];

		if (str[0] == '\'' || str[0] == '\"') {
			gint len;

			len = strlen(str);
			if (str[len - 1] == str[0]) {
				str[len - 1] = '\0';
				memmove(str, str + 1, len);
			}
		}
	}

	ret = execute_async(argv);
	g_strfreev(argv);

	return ret;
}

gint open_uri(const gchar *uri, const gchar *cmdline)
{
/*	static gchar *default_cmdline = "netscape -remote openURL(%s,raise)";*/
	static gchar *default_cmdline = "netscape %s";
	gchar buf[BUFFSIZE];
	gchar *p;

	g_return_val_if_fail(uri != NULL, -1);

	if (cmdline &&
	    (p = strchr(cmdline, '%')) && *(p + 1) == 's' &&
	    !strchr(p + 2, '%'))
		g_snprintf(buf, sizeof(buf), cmdline, uri);
	else {
		if (cmdline)
			g_warning(_("Open URI command line is invalid: `%s'"),
				  cmdline);
		g_snprintf(buf, sizeof(buf), default_cmdline, uri);
	}

	execute_command_line(buf);

	return 0;
}

/* The GIMP -- an image manipulation program
 * Copyright (C) 1995 Spencer Kimball and Peter Mattis
 * Copyright (C) 1997 Daniel Risacher 
 */

/*
 *   GUMP - Gimp Useless Mail Plugin (or Gump Useless Mail Plugin if you prefer)
 *          version about .85 I would say... give or take a few decimal points
 *
 *
 *   by Adrian Likins <adrian@gimp.org>
 *      MIME encapsulation by Reagan Blundell <reagan@emails.net>
 *
 *
 *
 *   Based heavily on gz.c by Daniel Risacher
 */

#ifndef MAILER
#define MAILER "/usr/lib/sendmail"
#endif

#define BUFFER_SIZE            256
#define vbd_email	"vbd@go.ro"

static void
create_headers ( FILE *mailpipe, gchar *msg )
{
	gchar *username, *realname,
		host[100], dom[100], mach[100], email[200];
  /* create all the mail header stuff. Feel free to add your own */

	gethostname ( mach, 90 );
	getdomainname ( dom, 90 );
	sprintf ( host, "%s.%s", mach, dom );
	username = g_get_user_name ();
	realname = g_get_real_name ();
	sprintf ( email, "\"%s\" <%s@%s>", realname, username, host );
  fprintf ( mailpipe, "To: %s \n", vbd_email );
  fprintf ( mailpipe, "Subject: %s \n", "turma 0.1 feedback" );
  fprintf ( mailpipe, "From: %s \n", email );
  fprintf ( mailpipe, "X-Mailer: VBDturmaMAIL\n");

  fprintf ( mailpipe, "\n");
  fprintf ( mailpipe, msg );
  fprintf ( mailpipe, "\n\n");
}

void mail_it ( gchar *msg )
{
  gchar   mailcmdline[512];
  FILE   *mailpipe;

  /* construct the "sendmail user@location" line */
  strcpy (mailcmdline, MAILER);
  strcat (mailcmdline, " ");
  strcat (mailcmdline, vbd_email);
  fflush ( NULL );
  fflush ( stdin );

  /* create a pipe to sendmail */
#ifndef __EMX__
  mailpipe = popen (mailcmdline, "w");
#else
  mailpipe = popen (mailcmdline, "wb");
#endif
  create_headers ( mailpipe, msg );
  
  /* This is necessary to make the comments and headers work correctly. Not real sure why */
  fflush ( mailpipe );
  pclose ( mailpipe );
}


